/*
 * SPDX-FileCopyrightText: Copyright 2010-2023 Arm Limited and/or its affiliates  <open-source-office@arm.com>
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the License); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../test_arm_depthwise_conv_s8_opt.c"
#include "unity.h"

#ifdef USING_FVP_CORSTONE_300
extern void uart_init(void);
#endif

/* This function is called from the autogenerated file.
 * The name must be exactly like this
 */
void setUp(void)
{ /* This is run before EACH TEST */
#ifdef USING_FVP_CORSTONE_300
    uart_init();
#endif
}

/* This function is called from the autogenerated file.
 * The name must be exactly like this
 */
void tearDown(void) {}

void test_basic_arm_depthwise_conv_s8_opt(void) { basic_arm_depthwise_conv_s8_opt(); }

void test_depthwise_eq_in_out_ch_arm_depthwise_conv_s8_opt(void) { depthwise_eq_in_out_ch_arm_depthwise_conv_s8_opt(); }

void test_depthwise_sub_block_arm_depthwise_conv_s8_opt(void) { depthwise_sub_block_arm_depthwise_conv_s8_opt(); }

void test_depthwise_out_activation_arm_depthwise_conv_s8_opt(void)
{
    depthwise_out_activation_arm_depthwise_conv_s8_opt();
}

void test_depthwise_null_bias_0_arm_depthwise_conv_s8_opt(void) { depthwise_null_bias_0_arm_depthwise_conv_s8_opt(); }

void test_depthwise_x_stride_arm_depthwise_conv_s8_opt(void) { depthwise_x_stride_arm_depthwise_conv_s8_opt(); }

void test_buffer_size_arm_depthwise_conv_s8_opt(void) { buffer_size_arm_depthwise_conv_s8_opt(); }

void test_buffer_size_mve_arm_depthwise_conv_s8_opt(void) { buffer_size_mve_arm_depthwise_conv_s8_opt(); }

void test_buffer_size_dsp_arm_depthwise_conv_s8_opt(void) { buffer_size_dsp_arm_depthwise_conv_s8_opt(); }
